

DROP TABLE IF EXISTS config;
CREATE TABLE `config` (
  `config_id` int(11) NOT NULL auto_increment,
  `config_site_title` varchar(256) default NULL,
  `config_site_description` varchar(256) default NULL,
  `config_site_keyword` text default NULL,
  `config_operator_description` text default NULL,
  `config_description` text default NULL,
  `config_admin_email` varchar(128) default NULL,
  `config_admin_yahoo_id` varchar(128) default NULL,
  `config_admin_username` varchar(128) default NULL,
  `config_admin_password` varchar(128) default NULL,
  `config_input_validate` varchar(2) default 1,
  PRIMARY KEY  (`config_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS payment;
CREATE TABLE IF NOT EXISTS `payment` (
  `payment_id` int(11) NOT NULL AUTO_INCREMENT,
  `payment_user` varchar(128) default NULL,
  `payment_email` varchar(128) default NULL,
  `payment_mobile` varchar(30) default NULL,
  `payment_nam` varchar(30) default NULL,
  `payment_bab` varchar(30) default NULL,
  `payment_pool` varchar(30) default NULL,
  `payment_amount` int(11) default NULL,
  `payment_gateway` varchar(128) default NULL,
  `payment_res_num` varchar(64) DEFAULT NULL,
  `payment_ref_num` varchar(64) DEFAULT NULL,
  `payment_status` varchar(2) NOT NULL DEFAULT '1',
  `payment_rand` varchar(64) default NULL,
  `payment_time` varchar(30) default NULL,
  `payment_ip` varchar(15) default NULL,
  PRIMARY KEY (`payment_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
DROP TABLE IF EXISTS plugin;
CREATE TABLE `plugin` (
  `plugin_id` int(11) NOT NULL auto_increment,
  `plugin_uniq` varchar(128) character set latin1 collate latin1_general_ci default NULL,
  `plugin_name` varchar(128) default NULL,
  `plugin_type` varchar(128) character set latin1 collate latin1_general_ci default NULL,
  `plugin_status` varchar(2) character set latin1 collate latin1_general_ci default NULL,
  `plugin_time` varchar(30) character set latin1 collate latin1_general_ci default NULL,
  PRIMARY KEY  (`plugin_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

DROP TABLE IF EXISTS plugindata;
CREATE TABLE `plugindata` (
  `plugindata_id` int(11) NOT NULL auto_increment,
  `plugindata_uniq` varchar(128) default NULL,
  `plugindata_field_name` varchar(256) default NULL,
  `plugindata_field_value` text default NULL,
  PRIMARY KEY  (`plugindata_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


