<?
/*
  SOFTIRAN
  http://www.softiran.org

*/
	//-- اطلاعات کلی پلاگین
	$pluginData[pasfreer][type] = 'payment';
	$pluginData[pasfreer][name] = 'درگاه پرداخت الکترونیک سپهر';
	$pluginData[pasfreer][uniq] = 'pasfreer';
	$pluginData[pasfreer][description] = 'مخصوص پرداخت با دروازه پرداخت پرداخت الکترونیک سپهر';
	$pluginData[pasfreer][author][name] = 'softiran';
	$pluginData[pasfreer][author][url] = 'http://www.softiran.org';
	$pluginData[pasfreer][author][email] = 'esmailian12@gmail.com';
	
	//-- فیلدهای تنظیمات پلاگین
	$pluginData[pasfreer][field][config][1][title] = 'ترمینال';
	$pluginData[pasfreer][field][config][1][name] = 'terminal';


	//-- تابع انتقال به دروازه پرداخت
	function gateway__pasfreer($data)
	{
		$terminal 	= trim($data[terminal]);
		$invoiceNumber =  trim($data[invoice_id]);
		$amount =  trim($data[amount]);
		$redirectAddress =  $data[callback];
		
		$params ='terminalID='.$terminal.'&Amount='.$amount.'&callbackURL='.urlencode($redirectAddress).'&invoiceID='.$invoiceNumber;
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/GetToken');
		curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$res = curl_exec($ch);
		curl_close($ch);
		if($res)
		{
			$res = json_decode($res,true);
			if($res['Status'] == '0')
			{
				echo '<form id="paymentUTLfrm" action="https://mabna.shaparak.ir:8080" method="POST">
					<input type="hidden" id="TerminalID" name="TerminalID" value="'.$terminal.'">
					<input type="hidden" id="token" name="token" value="'.$res['Accesstoken'].'">
					</form><script>
					function submitmabna() {
					document.getElementById("paymentUTLfrm").submit();
					}
					window.onload=submitmabna; </script>';
			}else
			{
				$data[title] = 'خطای سیستم1';
				$data[message] = 'خطا در ساخت توکن <br/> کد خطا :'.$res['Status'];
				$query	= 'SELECT * FROM `config` WHERE `config_id` = "1" LIMIT 1';
				$conf	= $db->fetch($query);
				$smarty->assign('config', $conf);
				$smarty->assign('data', $data);
				$smarty->display('message.tpl');
				exit;
			}
		}else
		{
			$data[title] = 'خطای سیستم2';
			$data[message] = 'پورت 8081 در هاست شما بسته است !';
			$query	= 'SELECT * FROM `config` WHERE `config_id` = "1" LIMIT 1';
			$conf	= $db->fetch($query);
			$smarty->assign('config', $conf);
			$smarty->assign('data', $data);
			$smarty->display('message.tpl');
			exit;
		}
	
	}
	
	//-- تابع بررسی وضعیت پرداخت
	function callback__pasfreer($data)
	{
		global $db,$get,$post;

		$terminal 	= trim($data[terminal]);
		

		if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
		{
			$RefNum = $post['digitalreceipt'];
			
			$sql 		= 'SELECT count(*) as cc FROM `payment` WHERE `payment_ref_num` = "'.$RefNum.'" LIMIT 1;';
			$payment_ref_num 	= $db->fetch($sql);
			if($payment_ref_num[cc] > 0 )
			{
				$output[status]	= 0;
				$output[message]= 'رسید قبلا استفاده شده است.';
				return $output;
			}
			
			$params ='digitalreceipt='.$_POST['digitalreceipt'].'&Tid='.$terminal;
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/Advice');
			curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			$res = curl_exec($ch);
			curl_close($ch);
			$result = json_decode($res,true);
			
			if (strtoupper($result['Status']) == 'OK') 
			{
				$ResNum = $post['invoiceid'];
				$sql 		= "SELECT * FROM `payment` WHERE `payment_rand` = '".$ResNum."' LIMIT 1;";
				$payment 	= $db->fetch($sql);
				if($payment[payment_status] == 1)
				{
					if(floatval($result['ReturnId']) == floatval($payment[payment_amount]))
					{
						$output[status]		= 1;
						$output[res_num]	= $post['rrn'];
						$output[ref_num]	= $RefNum;
						$output[payment_id]	= $payment[payment_id];
					}else
					{
						$output[status]	= 0;
						$output[message]= 'مبلغ پرداختی با قیمت کالا برابر نیست .';
					}	
				}
				else
				{
					$output[status]	= 0;
					$output[message]= 'پرداخت قبلا تکمیل شده است .';
				}
				
			} else 
			{
				switch($result['ReturnId'])
				{
					case '-1' : $res = 'تراکنش پیدا نشد';break;
					case '-2' : $res = 'تراکنش قبلا Reverse شده است';break;
					case '-3' : $res = 'خطا عمومی';break;
					case '-4' : $res = 'امکان انجام درخواست برای این تراکنش وجود ندارد';break;
					case '-5' : $res = 'آدرس IP پذیرنده نامعتبر است';break;
					default  : $res = 'خطای ناشناس : '.$result['ReturnId'];break;
					
				}
				
				$output[status]	= 0;
				$output[message]= $res;
			}

		}else
		{
			$output[status]	= 0;
			$output[message]= $_POST['respmsg'];
		}
		return $output;
	}